#!/usr/bin/env python
# -*- coding: utf-8 -*-
# Filename: choosePlayer.py 


from PyQt4.QtGui import *
from PyQt4.QtCore import *
import os
from players import supportedPlayers


class choosePlayer(QDialog):
	
	def __init__(self, parent = None, *args):
		QDialog.__init__(self, parent)
		self.setMinimumWidth(250)
		self.setWindowTitle(_('Choose a player'))
		self.setWindowIcon(QIcon('./icon/lrcShow-X.png'))
		self.supportedPlayers = supportedPlayers
		mainLayout = QVBoxLayout(None)
		layout1 = QVBoxLayout(None)
		layout1.setContentsMargins(0,20,0,20)
		layout2 = QHBoxLayout(None)
		layout2.setContentsMargins(0,0,0,10)
		self.playerLabel = QLabel(_('Please choose a player:'), self)
		self.playerList = QComboBox(self)
		for i in self.supportedPlayers:
			self.playerList.addItem(i)
		layout2.addWidget(self.playerLabel)
		layout2.addWidget(self.playerList)
		
		self.pathBox = QLineEdit(self)
		layout1.addLayout(layout2)
		layout1.addWidget(self.pathBox)
		
		self.rememberPlayer = QCheckBox(_('Always launch the chosen player'), self)
		
		buttonBox = QDialogButtonBox(self)
		self.okButton = QPushButton(QIcon('./icon/ok.png'), _('Ok'))
		self.cancelButton = QPushButton(QIcon('./icon/cancel.png'), _('Cancel'))
        	buttonBox.addButton(self.okButton, QDialogButtonBox.AcceptRole)
        	buttonBox.addButton(self.cancelButton, QDialogButtonBox.RejectRole)

		mainLayout.addLayout(layout1)
		mainLayout.addWidget(self.rememberPlayer)
		mainLayout.addWidget(buttonBox)
		self.setLayout(mainLayout)
		
		self.connect(buttonBox, SIGNAL('accepted()'), self, SLOT('accept()'))
        	self.connect(buttonBox, SIGNAL('rejected()'), self, SLOT('reject()'))
		self.connect(self.playerList, SIGNAL('activated(QString)'), self.changePath)
		self.connect(self.pathBox, SIGNAL('textChanged(QString)'), self.checkPath)
		
	def changePath(self, e):
		if(e == 'xmms2'):
			e = 'xmms2-launcher'
		te = '/usr/bin/%s' %e
		te = QString(te)
		self.pathBox.setText(te)
		self.checkPath(te)
		
	def checkPath(self, t):
		t = str(t.toLocal8Bit())
		if(os.path.isfile(t) and os.access(t, os.X_OK)):
			color = QColor(255,255,255)
			self.okButton.setDisabled(False)
		else:
			color = QColor(255,224,224)
			self.okButton.setDisabled(True)
		pl = QPalette()
		pl.setColor(QPalette.Window, color)
		pl.setColor(QPalette.Base, color)
		self.pathBox.setPalette(pl)
		
		p = t.split('/')[-1]
		if(p in self.supportedPlayers and p != str(self.playerList.currentText())):
			self.playerList.setCurrentIndex(self.supportedPlayers.index(p))