#!/usr/bin/env python
# -*- coding: utf-8 -*-
# Filename: audacious.py

from playerBase import Status
from dbusplayer import dbusPlayer

class audacious(dbusPlayer):
	
	def __init__(self):
		self.process = ("audacious","audacious2")
		dbusPlayer.__init__(self,"audacious","org.mpris.audacious","/Player","org.freedesktop.MediaPlayer")
		self.iface.connect_to_signal("StatusChange", self.statusChanged)
	
	#TRACK SECTION
	def getTitle(self):
		try:
			return self.iface.GetMetadata()['title']
		except KeyError:
			return ""
	
	def getArtist(self):
		try:
			return self.iface.GetMetadata()['artist']
		except KeyError:
			return ""
	
	def getTimePoint(self): #precision to ms
		return self.iface.PositionGet()
	
	def getMediaFile(self):
		md = self.iface.GetMetadata()
		try:
			return md['URI']
		except:
			return md['location']
	
	#PLAYER SECTION
	def getStatus(self):
		return self.toStatus(self.iface.GetStatus())
		
	def playFunc(self):
		self.iface.Play()
	
	def pauseFunc(self):
		self.iface.Pause()
	
	def stopFunc(self):
		self.iface.Stop()
	
	def prevFunc(self):
		self.iface.Prev()
	
	def nextFunc(self):
		self.iface.Next()
	
	#EVENTS SECTION
	def toStatus(self,status):
		if not status in range(3):
			status = status[0]
		return {0:Status().Playing,1:Status().Paused,2:Status().Stopped}[status]
	
	def statusChanged(self,arg):
		if self.callback == None:
			return
		self.callback(self.toStatus(arg))