#!/usr/bin/env python
# -*- coding: utf-8 -*-
# Filename:  banshee.py

import commands,os
from urllib import unquote
from playerBase import Status
from dbusplayer import dbusPlayer

class banshee(dbusPlayer):
	
	def __init__(self):
		self.process = "banshee-1"
		ifaces = []
		ifaces.append(("org.bansheeproject.Banshee","/org/bansheeproject/Banshee/PlaybackController","org.bansheeproject.Banshee.PlaybackController"))
		ifaces.append(("org.bansheeproject.Banshee","/org/bansheeproject/Banshee/PlayerEngine","org.bansheeproject.Banshee.PlayerEngine"))
		dbusPlayer.__init__(self,"banshee",ifaces[0],ifaces[1])
		self.iface[1].connect_to_signal("StateChanged", self.statusChanged)
	
	#TRACK SECTION
	def getTitle(self):
		try:
			return self.iface[1].GetCurrentTrack()["name"]
		except:
			return ""
	
	def getArtist(self):
		try:
			return self.iface[1].GetCurrentTrack()["artist"]
		except:
			return ""
	
	def getTimePoint(self):
		try:
			return self.iface[1].GetPosition()
		except:
			return 0
	
	def getMediaFile(self):
		try:
			return self.iface[1].GetCurrentTrack()["local-path"]
		except:
			return ""
	
	#PLAYER SECTION
	def getStatus(self):
		return self.toStatus(self.iface[1].GetCurrentState())
		
	def playFunc(self):
		self.iface[1].Play()
	
	def pauseFunc(self):
		self.iface[1].Pause()
	
	def stopFunc(self):
		self.iface[1].Pause()
	
	def prevFunc(self):
		self.iface[0].Previous(False)
	
	def nextFunc(self):
		self.iface[0].Next(False)
	
	#EVENTS SECTION
	def toStatus(self,status):
		if str(status) == "playing":
			return Status().Playing
		elif str(status) == "paused":
			return Status().Paused
		else:
			return Status().Stopped
	
	def statusChanged(self,arg):
		if str(arg) not in ('playing','paused'):
			return
		if self.callback != None:
			self.callback(self.toStatus(arg))

