#!/usr/bin/env python
# -*- coding: utf-8 -*-
# Filename:  muine.py

from playerBase import Status
from dbusplayer import dbusPlayer

class muine(dbusPlayer):
	
	def __init__(self):
		self.process = "muine"
		dbusPlayer.__init__(self,"muine","org.gnome.Muine","/org/gnome/Muine/Player","org.gnome.Muine.Player")
		self.iface.connect_to_signal("StateChanged", self.statusChanged)
		self.iface.connect_to_signal("SongChanged", self.songChanged)
	
	#TRACK SECTION
	def getMetadata(self):
		data = self.iface.GetCurrentSong().splitlines()
		ret = {}
		for line in data:
			line = line.split(": ")
			if len(line) == 2:
				ret[line[0]] = line[1]
		return ret

	def getTitle(self):
		return self.getMetadata()["title"]
	
	def getArtist(self):
		return self.getMetadata()["artist"]
	
	def getTimePoint(self):
		return self.handleTime(self.iface.GetPosition()*1000)
	
	def getMediaFile(self):
		return self.getMetadata()["uri"]
	
	#PLAYER SECTION
	def getStatus(self):
		return self.toStatus(self.iface.GetPlaying())
		
	def playFunc(self):
		self.iface.SetPlaying(True)
	
	def pauseFunc(self):
		self.iface.SetPlaying(False)
	
	def stopFunc(self):
		self.iface.SetPlaying(False)
	
	def prevFunc(self):
		self.iface.Previous()
	
	def nextFunc(self):
		self.iface.Next()
	
	#EVENTS SECTION
	def toStatus(self,status):
		if not status:
			return Status().Paused
		else:
			return Status().Playing
	
	def statusChanged(self,*arg):
		if self.callback != None:
			if not arg:
				arg = self.getStatus()
			else:
				arg = self.toStatus(arg)
			self.callback(arg)
	
	def songChanged(self,*arg):
		if self.callback != None:
			self.callback(Status().Playing)

