#!/usr/bin/env python
# -*- coding: utf-8 -*-
# Filename:  vlc.py

from playerBase import Status
from dbusplayer import dbusPlayer

class vlc(dbusPlayer):
	
	def __init__(self):
		self.process = "vlc"
		dbusPlayer.__init__(self,"vlc","org.mpris.vlc","/Player","org.freedesktop.MediaPlayer")
		self.iface.connect_to_signal("StatusChange", self.statusChanged)
	
	#TRACK SECTION
	def getTitle(self):
		return self.iface.GetMetadata()['title']
	
	def getArtist(self):
		return self.iface.GetMetadata()['artist']
	
	def getTimePoint(self):
		return self.iface.PositionGet()
	
	def getMediaFile(self):
		return self.iface.GetMetadata()['location']
	
	#PLAYER SECTION
	def getStatus(self):
		return self.iface.GetStatus()[0]
		
	def playFunc(self):
		self.iface.Play()
	
	def pauseFunc(self):
		self.iface.Pause()
	
	def stopFunc(self):
		self.iface.Stop()
	
	def prevFunc(self):
		self.iface.Prev()
	
	def nextFunc(self):
		self.iface.Next()
	
	#EVENTS SECTION
	def toStatus(self,status):
		if not status in range(3):
			status = status[0]
		return {0:Status().Playing,1:Status().Paused,2:Status().Stopped}[status]
	
	def statusChanged(self,arg):
		if self.callback != None:
			self.callback(self.toStatus(arg))
