#!/usr/bin/env python
# -*- coding: utf-8 -*-
# Filename: preferenceEngines.py

from PyQt4.QtGui import *
from PyQt4.QtCore import *
from engines.ui import *
import os


class preferenceEngines(QWidget):
	
	def __init__(self, parent = None, *args):
		QWidget.__init__(self, parent)
		self.updateModule = False

		mainLayout = QVBoxLayout(None)
		mainLayout.setContentsMargins(5, 10, 0, 0)
		
		self.table = QTableWidget(0,2,self)
		self.table.setEditTriggers(QAbstractItemView.NoEditTriggers)
        	self.table.setSelectionBehavior(QAbstractItemView.SelectRows)
		self.table.setSelectionMode(QAbstractItemView.SingleSelection)
		self.table.setMinimumWidth(350)
		title = QStringList()<<_('Engine names')<<_('Files')
		self.table.setHorizontalHeaderLabels(title)
		self.table.setColumnWidth(0,220)
		self.table.setColumnWidth(1,160)
		self.rowNumber = 0
		
		layout1 = QHBoxLayout(None)
		layout1.setContentsMargins(0, 0, 200, 0)
		self.configButton = QPushButton(QIcon('./icon/configure.png'), _('Setting...'), self)
		self.configButton.setEnabled(False)
		self.infoButton = QPushButton(QIcon('./icon/info.png'), _('Information...'), self)
		self.infoButton.setEnabled(False)
		layout1.addWidget(self.configButton)
		layout1.addWidget(self.infoButton)
		
		mainLayout.addWidget(self.table)
		mainLayout.addLayout(layout1)
		
		self.setLayout(mainLayout)
		
		self.connect(self.table, SIGNAL("cellClicked(int,int)"), self.enableButton)
		self.connect(self.configButton, SIGNAL("clicked()"), self.configEngine)
		self.connect(self.infoButton, SIGNAL("clicked()"), self.engineInfo)
	
	def addEngine(self, engine, fi):
		self.rowNumber += 1
		self.table.setRowCount(self.rowNumber)
		self.table.setItem(self.rowNumber-1, 0, QTableWidgetItem(engine, 0))
		self.table.setItem(self.rowNumber-1, 1, QTableWidgetItem(fi, 0))
	
	def enableButton(self, row, col):
		txt = self.table.item(row, 0).text()
		if(os.path.exists('./engines/ui/%sSettingUi.py' %txt)):
			self.configButton.setEnabled(True)
		else:
			self.configButton.setEnabled(False)
		if(os.path.exists('./engines/ui/%sInfoUi.py' %txt)):
			self.infoButton.setEnabled(True)
		else:
			self.infoButton.setEnabled(False)
	
	def configEngine(self):
		exec 'p = %sSettingUi(self)' %self.table.item(self.table.currentRow(), 0).text()
		result = p.exec_()
	
	def engineInfo(self):
		exec 'p = %sInfoUi(self)' %self.table.item(self.table.currentRow(), 0).text()
		result = p.exec_()