#!/usr/bin/env python
# -*- coding: utf-8 -*-
# Filename: preferenceGeneral.py
 
from PyQt4.QtCore import *
from PyQt4.QtGui import *


class preferenceGeneral(QWidget):
	
	def __init__(self, parent = None, *args):
		QWidget.__init__(self, parent)
		mainLayout = QVBoxLayout(None)
		mainLayout.setContentsMargins(5, 10, 0, 40)
		
		#self.autoInsert = QCheckBox('Auto send lrc to Amarok sidebar',self)
		self.completeTagSearch = QCheckBox(_('Search lrc only when has full tag information'), self)
		self.asTrackName = QCheckBox(_('Name the downloaded lrc file as media file\'s name'), self)
		self.lrcInMedia = QCheckBox(_('Prioritize using the lrc embedded in media file'), self)
		self.autoEmbed  =  QCheckBox(_('Auto embed the lrc into media file'), self)
		self.autoEmbedFromLocal = QCheckBox(_('Auto embed the lrc that from local'), self)
		self.autoEmbedFromLocal.setEnabled(False)
		self.autoEmbedFromNet = QCheckBox(_('Auto embed the lrc that from internet'), self)
		self.autoEmbedFromNet.setEnabled(False)
		
		layout3 = QHBoxLayout(None)
		layout3.setContentsMargins(0, 5, 100, 0)
		self.embedLable = QLabel(_('Tag type of embedding lyrics to operate:'), self)
		self.comboBoxType = QComboBox(self)
		self.strTagList = ['id3v2-uslt', 'apetag', 'lyrics3v2', 'lyrics3v1', 'id3v2-sylt']
		tagTypeList = QStringList()
		for i in self.strTagList:
			tagTypeList.append(i)
		self.comboBoxType.addItems(tagTypeList)
		layout3.addWidget(self.embedLable)
		layout3.addWidget(self.comboBoxType)
		
		
		layout1 = QHBoxLayout(None)
		layout1.setContentsMargins(0, 5, 180, 0)
		self.saveEncoderLabel = QLabel(_('Set encoding for saving:'), self)
		self.comboBox = QComboBox(self)
		self.strList = ['latin1', 'big5', 'big5-hkscs', 'eucjp', 'shift-jis', 'iso 2022-jp-1', 'euc-jisx0213', 'euckr', 'gb2312', 'gbk', 'gb18030', 'utf8', 'utf16', 'koi8-r', 'koi8-u', 'iso 8859-1', 'iso 8859-2', 'iso 8859-3', 'iso 8859-4', 'iso 8859-5', 'iso 8859-6', 'iso 8859-7', 'iso 8859-8', 'iso 8859-9', 'iso 8859-10', 'iso 8859-13', 'iso 8859-14', 'iso 8859-15', 'ibm850', 'ibm866', 'cp874', 'cp1250', 'cp1251', 'cp1252', 'cp1253', 'cp1254', 'cp1255', 'cp1256', 'cp1257', 'cp1258', 'tis-620', 'mac roman']
		codecList = QStringList()
		for i in self.strList:
			codecList.append(i)
		self.comboBox.addItems(codecList)
		layout1.addWidget(self.saveEncoderLabel)
		layout1.addWidget(self.comboBox)
		
		layout2 = QHBoxLayout(None)
		layout2.setContentsMargins(0, 5, 20, 0)
		self.proxyLabel = QLabel(_('Set http proxy:'), self)
		self.proxy = QLineEdit(self)
		layout2.addWidget(self.proxyLabel)
		layout2.addWidget(self.proxy)
		self.commentLabel = QLabel(_('Leave it empty if no proxy, the format is: http://xxx.yyy.zzz:ww'), self)
		
		mainLayout.addWidget(self.completeTagSearch)
		#mainLayout.addWidget(self.autoInsert)
		mainLayout.addWidget(self.asTrackName)
		mainLayout.addWidget(self.lrcInMedia)
		mainLayout.addWidget(self.autoEmbed)
		mainLayout.addWidget(self.autoEmbedFromLocal)
		mainLayout.addWidget(self.autoEmbedFromNet)
		mainLayout.addLayout(layout3)
		mainLayout.addLayout(layout1)
		mainLayout.addLayout(layout2)
		mainLayout.addWidget(self.commentLabel)
		
		self.setLayout(mainLayout)
		
		self.connect(self.autoEmbed, SIGNAL("toggled(bool)"), self.changeState)
		self.connect(self.autoEmbedFromLocal, SIGNAL("toggled(bool)"), self.checkAutoEmbedState)
		self.connect(self.autoEmbedFromNet, SIGNAL("toggled(bool)"), self.checkAutoEmbedState)
		self.connect(self.autoEmbed, SIGNAL("clicked(bool)"), self.chooseAll)
	
	def chooseAll(self, checked):
		if(checked):
			self.autoEmbedFromLocal.setChecked(True)
			self.autoEmbedFromNet.setChecked(True)
	
	def changeState(self, checked):
		self.autoEmbedFromLocal.setEnabled(checked)
		self.autoEmbedFromNet.setEnabled(checked)
	
	def checkAutoEmbedState(self, checked):
		if(not self.autoEmbedFromLocal.isChecked() and not self.autoEmbedFromNet.isChecked()):
			self.autoEmbed.setChecked(False)