#!/usr/bin/env python
# -*- coding: utf-8 -*-
# Filename: searchLocalLrc.py
# Author: Xu Jia (Sanfanling)   E-mail:xujia19@gmail.com
# Lisence: GPL-2.0

import os, glob

class searchLocalLrc:
	
	def __init__(self, searchTag, path, recursionDepth, artist, title, searchMediaPath, extPath, extInfo):
		self.searchTag = searchTag
		self.path = path
		self.recursionDepth = recursionDepth
		self.artist = artist
		self.title = title
		self.searchMediaPath = searchMediaPath
		self.extPath = extPath
		self.extInfo = extInfo
		
	def search(self):
		searchTmp = self.getSearchLocalPath()
		depTmp = map(lambda x: int(x), self.recursionDepth)
		if(searchTmp):
			k = []
			if(self.searchTag):
				k = self.getLrc('TAG', k, searchTmp, depTmp)
			k = self.getLrc('NAME', k, searchTmp, depTmp)
			return k
		else:
			return False
	
	def getSearchLocalPath(self):
		if(len(self.path) >0 or self.searchMediaPath=='yes'):
			searchTmp=self.path[:]
			if(self.searchMediaPath=='yes'):
				searchTmp.append(self.extPath)
			return searchTmp
		else:
			return None
	
	def searchLocalLrcFromTag(self, k, path, dep):
		dep -= 1
		for lrcfile in glob.glob(os.path.join(path, '*.[Ll][Rr][Cc]')):
			filename = os.path.basename(lrcfile)
			if(self.title.lower() in filename.lower() and self.artist.lower() in filename.lower()):
				if(lrcfile not in k):
					k.append(lrcfile)
		if(dep < 0):
			return k
		else:
			sp = os.listdir(path)
			sp = map(lambda x: os.path.join(path, x), sp)
			sp = filter(lambda x: os.path.isdir(x), sp)
			for j in sp:
				k = self.searchLocalLrcFromTag(k, j, dep)
			return k
	
	def searchLocalLrcFromName(self, k, path, dep):
		dep -= 1
		for lrcfile in glob.glob(os.path.join(path, '*.[Ll][Rr][Cc]')):
			filename = os.path.basename(lrcfile)
			if(self.extInfo == os.path.splitext(filename)[0]):
				if(lrcfile not in k):
					k.append(lrcfile)
		if(dep < 0):
			return k
		else:
			sp = os.listdir(path)
			sp = map(lambda x: os.path.join(path, x), sp)
			sp = filter(lambda x: os.path.isdir(x), sp)
			for j in sp:
				k = self.searchLocalLrcFromName(k, j, dep)
			return k
	
	def getLrc(self, rule, k, searchTmp, depTmp):
		for tmp in zip(searchTmp, depTmp):
			if(rule == 'TAG'):
				k = self.searchLocalLrcFromTag(k, tmp[0], tmp[1])
			elif(rule == 'NAME'):
				k = self.searchLocalLrcFromName(k, tmp[0], tmp[1])
		return k
